    .TEXT

	PSR_IRQ_MODE            =   0x12
	PSR_SYS_MODE            =   0x1f
	WRAM_END                =   0x03008000

    .GLOBAL     _start
_start:
    .INCLUDE    "rom_header.s"

    .EXTERN     AgbMain
    .GLOBAL     start_vector
    .CODE 32
start_vector:
        mov     r0, #PSR_IRQ_MODE
        msr     cpsr, r0
        ldr     sp, sp_irq
        mov     r0, #PSR_SYS_MODE
        msr     cpsr, r0
        ldr     sp, sp_usr
        ldr     r1, =AgbMain
        mov     lr, pc
        bx      r1
        b       start_vector

    .ALIGN
sp_usr: .word   WRAM_END - 0x100
sp_irq: .word   WRAM_END - 0x60



    .END

